package com.imageresizer.codec.target;

import android.content.Context;
import android.graphics.drawable.Drawable;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.bumptech.glide.gifdecoder.StandardGifDecoder;
import com.bumptech.glide.load.resource.gif.GifDrawable;
import com.bumptech.glide.request.target.CustomTarget;
import com.bumptech.glide.request.transition.Transition;
import com.imageresizer.codec.DecoderProvider;
import com.imageresizer.codec.encoder.webp.codec.WebpBitmapEncoder;
import com.imageresizer.utility.FileUtility;
import com.imageresizer.utility.StaticOptions;

import java.io.File;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class TargetGif extends CustomTarget<GifDrawable> {
    private final String TAG = TargetGif.class.getCanonicalName();
    private final StaticOptions options;
    CodecCallback callback;
    Context context;
    private ExecutorService executor = Executors.newSingleThreadExecutor(); // Create an Executor

    public TargetGif(Context context, CodecCallback callback, StaticOptions options) {
        this.context = context;
        this.callback = callback;
        this.options = options;

    }


    @Override
    public void onResourceReady(@NonNull GifDrawable resource, @Nullable Transition<? super GifDrawable> transition) {

        executor.submit(()->{
            StandardGifDecoder decoder = null;

            try {
                decoder = DecoderProvider.getDecoder(resource);
            } catch (IllegalAccessException | NoSuchFieldException e) {
                throw new RuntimeException(e);
            }

            StandardGifDecoder finalWebpDecoder = decoder;
            // create new File;
//            File outFile =  new FileUtility().createOutputFile(format);
//
//            if(imageType.toLowerCase().equals("webp")){
//                // Encoder
//                WebpBitmapEncoder encoder =null;
//            }





            // finall close and inform
//            callback.onComplete(outFile.getAbsolutePath());
        });




    }

    @Override
    public void onLoadCleared(@Nullable Drawable placeholder) {

    }
}
